import java.util.ArrayList;
import java.util.Iterator;

import java.awt.event.*;

public class RaumplanerController{

  private static ArrayList<Moebel> alleMoebel = new ArrayList<Moebel>();
  private static Moebel ausgewaehlt,mausWahl;
  private static Iterator<Moebel> it;

  public RaumplanerController(RaumplanerGui gui){
    ausgewaehlt = null;
    it=null;
    erzeugeListener();
  }

  public void neuesMoebel(String typ) {
    Moebel moebel = null;
    if (typ=="Tisch") moebel=new Tisch(310,310,"grau",0,100,70);
    else if (typ=="Stuhl") moebel=new Stuhl(310,10,"blau",0,40,40);
    else if (typ=="Schrank") moebel=new Schrank(10,310,"blau",0,60,37);
    else if (typ=="Schrankwand") moebel=new Schrankwand(3);
    else if (typ=="Tischgruppe") moebel=new Tischgruppe(2);
    else if (typ=="Konferenztisch") moebel=new KonferenzTisch(100,300,"gruen",0,30);
    else if (typ=="KonferenzTischGruppe") moebel=new KonferenzTischGruppe(3);
    else return;
    auswahlBeenden();
    alleMoebel.add(moebel);
    moebel.zeige();
  }
  
  public void auswahlBeenden(){
    markierungLoeschen();
    ausgewaehlt = null;
    it=null;
  }
  
  public void markierungLoeschen(){
    if (ausgewaehlt!=null) {
      ausgewaehlt.verberge();
      ausgewaehlt.setzeAuswahl(false);
      ausgewaehlt.zeige();
    }
  }

  public Moebel auswahl(){
    // zuerst alte Markierung loeschen:
    markierungLoeschen();
    // neu auswaehlen:
    if (it==null) it=alleMoebel.iterator();
    if (it.hasNext()) ausgewaehlt=it.next();
    else auswahlBeenden();
    // neu markieren:
    if (ausgewaehlt!=null) {
      ausgewaehlt.verberge();
      ausgewaehlt.setzeAuswahl(true);
      ausgewaehlt.zeige();
    }
    return ausgewaehlt;
  }
  public static void verschiebe(){
    if (ausgewaehlt!=null)
    ausgewaehlt.bewegeHorizontal(50);
  }
  
  private void erzeugeListener(){
    Leinwand leinwand = Leinwand.gibLeinwand();
    leinwand.gibZeichenflaeche().addMouseListener(new MouseAdapter(){
      public void mouseClicked(MouseEvent e){
        //System.out.println("Koordinaten: "+e.getX()+" / "+e.getY());
        for (Moebel moebel:alleMoebel) {
          //mausWahl=moebel;
          if (moebel.transformiere(moebel.gibAktuelleFigur()).contains(e.getX(), e.getY())) {
            markierungLoeschen();
            ausgewaehlt=moebel;
            ausgewaehlt.verberge();
            ausgewaehlt.setzeAuswahl(true);
            ausgewaehlt.zeige();
          }
        }

      }
    });
  }
}