import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.util.ArrayList;
import java.util.List;

/**
 * Eine Schrankwand, die manipuliert werden kann und sich selbst auf einer Leinwand zeichnet.
 */
public class Schrankwand extends Gruppe
{
    private int anzahl;

    /**
    * Erzeuge eine neue Schrankwand mit einer Standardfarbe und Standardgroesse
    * an einer Standardposition.
    * Der Konstruktor muss die Zahl der Schraenke uebergeben bekommen.
    */
    public Schrankwand(int anzahl)
    {
        super(350, 40, "lila", 90);
        this.anzahl=anzahl;
        if (anzahl<1) this.anzahl=1;
        if (anzahl>5) this.anzahl=5;
        init();
    }
  
  
    /**
    * erzeugt die Elemente.
    */
    protected void init() {
        super.init();
        for (int i=0;i<anzahl;i++)
        fuegeHinzu(new Schrank(i*60, 0, farbe, 0, 60, 37));
    }
}
